SUBROUTINE BOUND2D(ETAF,UAF,VAF)
!
!            BOUND is a modified version of a
!            boundary condition routine written by
!            E. A. Martinsen DNMI .
!
!***PURPOSE BOUND relaxes the solution in the FRS-zone
!           towards a specified FRS-zone solution.
!
!***DESCRIPTION
!
!           BOUND uses the FRS-bondary condition to specify
!           the solution in specified boundary zones.
!
!   ON ENTRY
!
!***ROUTINES CALLED RELAX
!***END PROLOGUE BOUND2D
!
!   Global variables
!
  USE MOD_BOUND
  IMPLICIT NONE
REAL, DIMENSION(IM,JM) :: UAF,VAF,ETAF
!
  INTEGER I,J,K
!
!
     CALL RELAX(ALPHAE,ETAFRS,ETATFRS,ETAF,1,1)
     CALL RELAX(ALPHAE,UAFRS,UATFRS,UAF,2,1)
     CALL RELAX(ALPHAE,VAFRS,VATFRS,VAF,3,1)
!
!  For the river case Neumann conditions may be more appropriate.
!
!     DO J = 13,14
!       ETAF(1,J) = 0.
!       ETAF(2,J) = 0.
!       UAF(1,J) = UAF(3,J)
!       UAF(2,J) = UAF(3,J)
!       VAF(1,J) = 0.
!       VAF(2,J) = 0.
!     END DO
!     DO I = 15,18
!       ETAF(I,1) = 0.
!       ETAF(I,2) = 0.
!       VAF(I,1) = VAF(I,3)
!       VAF(I,2) = VAF(I,3)
!       UAF(I,1) = 0.
!       UAF(I,2) = 0.
!     END DO
!
!
     DO J = 1,JM
        DO I = 1,IM
           ETAF(I,J)=ETAF(I,J)*FSM(I,J)
           UAF(I,J) = UAF(I,J)*DUM(I,J)
           VAF(I,J) = VAF(I,J)*DVM(I,J)
        END DO
     END DO
!
!
!***END BOUND2D
!
RETURN
END SUBROUTINE BOUND2D
