SUBROUTINE SETUP
USE MOD_MAIN
IMPLICIT NONE
REAL AMLIM,AMLIME
!
READ(40,*)ISTART(1)
READ(40,*)ISTART(2)
READ(40,*)ISTART(3)
READ(40,*)ISTART(4)
!
! NDATE is running time
!
DO I = 1,4
   NDATE(I) = ISTART(I)
END DO
NDATE(5) = 0 !  HOURs since start
!
!
! TIME is measuring time in days since start.
!
  TIME = 0.
!
READ(40,*)THETA2D
IF (THETA2D.LT.0.5 .OR. THETA2D.GT.1.0) THEN
  WRITE(*,*)'ERROR IN THETA2D',THETA2D
  WRITE(*,*)'THETA2D MUST BE IN THE RANGE 0.5 TO 1.0'
  STOP
ENDIF

READ(40,*)SMAG
READ(40,*)VISCPOM
READ(40,*)UNESCO
READ(40,*)ADVTURB
READ(40,*)RIVLOG
READ(40,*)TIDE
READ(40,*)WIND
READ(40,*)ATMPRESS
READ(40,*)FOURTH
READ(40,*)INTP4
READ(40,*)DEPMIN
READ(40,*)NFILTER
READ(40,*)DSBOT
READ(40,*)NDIVIS
READ(40,*)N2D
READ(40,*)NUMSTEP
!
! Compute the time step as a function of NDIVIS.
!
  DT = 3600./FLOAT(NDIVIS)
!
READ(40,*)DX
DY = DX
WRITE(*,*)'DX=',DX,'DY=',DY
READ(40,*)CM
READ(40,*)CM2D
READ(40,*)CH   
IF (.NOT.SMAG) THEN
  AM = CM
  AM2D = CM2D
  AH = CH
  AMLIME = 0.0625*DX**2/(DT/N2D) 
  AMLIM =  0.0625*DX**2/DT
  WRITE(*,*)'CONSTANT VISCOSITIES ARE CHOSEN'
  WRITE(*,*)'AM =',CM,'AM2D=',CM2D
  WRITE(*,*)'CONSTANT DIFFUSIVITY IS CHOSEN'
  WRITE(*,*)'AH =',CH
  WRITE(*,*)'MAXIMUM LIMITS ARE',AMLIM,' AND ',AMLIME,' RESPECTIVELY'
  IF (CM.GT.AMLIM .OR. CM2D.GT.AMLIME .OR. CH.GT.AMLIM) THEN
    WRITE(*,*)'AM, AH or AM2D CHOSEN TOO LARGE'
    STOP
  ENDIF
ELSEIF (SMAG) THEN
    WRITE(*,*)'VISCOSITIES ARE COMPUTED FROM SMAGORINSKY WITH:'
    WRITE(*,*)'CM =',CM,'AND',' CM2D=',CM2D, 'AND ','CH =',CH
ENDIF
READ(40,*)KMMIN
READ(40,*)KHMIN
READ(40,*)TECPLOT
RETURN
END SUBROUTINE SETUP
