SUBROUTINE STEPV3D(UBCLIN,VBCLIN,C3V,AY)
  USE STATE
  IMPLICIT NONE
  REAL UBCLIN(IM,JM,KB),VBCLIN(IM,JM,KB),C3V(IM,JM,KB),AY(IM,JM)
  REAL UV(IM,JM,KB)
  INTEGER I,J,K
!
!Define U*D in V-points.
!
!UV = 0.
!DO K = 1,KB-1
!  DO J = 2,JM
!     DO I = 2,IM-1
!        UV(I,J,K) = 0.25*(DU(I+1,J)*UBCLIN(I+1,J,K)+DU(I,J)*UBCLIN(I,J,K)+&
!             & DU(I+1,J-1)*UBCLIN(I+1,J-1,K)+DU(I,J-1)*UBCLIN(I,J-1,K))
!     END DO
!  END DO
!END DO
  UV = 0.
!$OMP PARALLEL DO PRIVATE(I,J,K)
  DO K = 1,KB-1
     DO J = 2,JM
        DO I = 2,IM-1
           IF (DVM(I,J).NE.0.) THEN
              IF (DUM(I+1,J).NE.0.) THEN
                 UV(I,J,K) = UBCLIN(I+1,J,K)*DU(I+1,J)/HUSQR(I+1,J)
              ENDIF
              IF (DUM(I,J).NE.0.) THEN
                 UV(I,J,K) = UV(I,J,K) + UBCLIN(I,J,K)*DU(I,J)/HUSQR(I,J)
              ENDIF
              IF (DUM(I+1,J-1).NE.0.) THEN
                 UV(I,J,K) = UV(I,J,K) + UBCLIN(I+1,J-1,K)*DU(I+1,J-1)/HUSQR(I+1,J-1)
              ENDIF
              IF (DUM(I,J-1).NE.0.) THEN
                 UV(I,J,K) = UV(I,J,K) + UBCLIN(I,J-1,K)*DU(I,J-1)/HUSQR(I,J-1)
              ENDIF
              UV(I,J,K) = 0.25*UV(I,J,K)*HVSQR(I,J)
           ENDIF
        END DO
     END DO
  END DO
!
!Then step forward the 3-D V-field
!
!
!$OMP PARALLEL DO PRIVATE(I,J,K)
  DO K = 1,KB-1
     DO J = 2,JM
        DO I = 2,IM-1
           DELTAV(I,J,K) = -COR(I,J)*UV(I,J,K)+DELTAV(I,J,K)-AY(I,J) 
           DELTAV(I,J,K) = DELTAV(I,J,K) + C3V(I,J,K)
        END DO
     END DO
  END DO
!$OMP PARALLEL DO PRIVATE(I,J,K) firstprivate(dt)
  DO J = 2,JM
     DO I = 2,IM-1
        IF (DVM(I,J).NE.0.) THEN
           DO K = 1,KB-1
              VBCLIN(I,J,K) = VBCLIN(I,J,K) + DT*DELTAV(I,J,K)/DV(I,J)
              V(I,J,K) = VBCLIN(I,J,K) + VA(I,J)              
           END DO
        ENDIF
     END DO
  END DO
  RETURN
END SUBROUTINE STEPV3D
